<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="X-UA-Compatible" content="IE=edge">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="None">
        
        
        <link rel="shortcut icon" href="img/favicon.ico">
        <title>PM4Py-mongo Documentation</title>
        <link href="css/bootstrap-custom.min.css" rel="stylesheet">
        <link href="css/font-awesome.min.css" rel="stylesheet">
        <link href="css/base.css" rel="stylesheet">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/github.min.css">
        <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
        <!--[if lt IE 9]>
            <script src="https://oss.maxcdn.com/libs/html5shiv/3.7.0/html5shiv.js"></script>
            <script src="https://oss.maxcdn.com/libs/respond.js/1.4.2/respond.min.js"></script>
        <![endif]-->

        <script src="js/jquery-1.10.2.min.js" defer></script>
        <script src="js/bootstrap-3.0.3.min.js" defer></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
        <script>hljs.initHighlightingOnLoad();</script> 
    </head>

    <body class="homepage">

        <div class="navbar navbar-default navbar-fixed-top" role="navigation">
            <div class="container">

                <!-- Collapsed navigation -->
                <div class="navbar-header">
                    <!-- Expander button -->
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="index.html">PM4Py-mongo Documentation</a>
                </div>

                <!-- Expanded navigation -->
                <div class="navbar-collapse collapse">
                        <!-- Main navigation -->
                        <ul class="nav navbar-nav">
                            <li class="active">
                                <a href="index.html">Start</a>
                            </li>
                            <li >
                                <a href="import.html">Importing</a>
                            </li>
                            <li >
                                <a href="filter.html">Filtering</a>
                            </li>
                            <li >
                                <a href="dfg.html">DFG Calculation</a>
                            </li>
                        </ul>

                    <ul class="nav navbar-nav navbar-right">
                        <li>
                            <a href="#" data-toggle="modal" data-target="#mkdocs_search_modal">
                                <i class="fa fa-search"></i> Search
                            </a>
                        </li>
                            <li class="disabled">
                                <a rel="next" >
                                    <i class="fa fa-arrow-left"></i> Previous
                                </a>
                            </li>
                            <li >
                                <a rel="prev" href="import.html">
                                    Next <i class="fa fa-arrow-right"></i>
                                </a>
                            </li>
                    </ul>
                </div>
            </div>
        </div>

        <div class="container">
                <div class="col-md-3"><div class="bs-sidebar hidden-print affix well" role="complementary">
    <ul class="nav bs-sidenav">
        <li class="main active"><a href="#start">Start</a></li>
            <li><a href="#setup">Setup</a></li>
            <li><a href="#usage-example">Usage &amp; Example</a></li>
    </ul>
</div></div>
                <div class="col-md-9" role="main">

<h1 id="start">Start</h1>
<p>This documentation describes all functions that are offered by the PM4Py-mongo library. The library consists of three different components: <em>importer</em>, <em>filter</em> and <em>dfg</em> that offer the corresponding functionality. They are described in more detail on their seperate pages that can be found in the header above.</p>
<hr />
<h2 id="setup">Setup</h2>
<p>The library is written in Python 3.6 which therefore must be installed on your machine.</p>
<p>This library is based on the document-based database system MongoDB. Therefore an installation of MongoDB is required to use this library. Learn how to install MongoDB <a href="https://docs.mongodb.com/manual/installation/#tutorial-installation">here</a>.</p>
<p>Once installed, a default MongoDB instance can be started from the command line using the following command.</p>
<pre><code>mongod --config /usr/local/etc/mongod.conf
</code></pre>
<p>The database will then be running.</p>
<p>In order to access the database inside Python, PM4Py-mongo uses the <em>PyMongo</em> library. Therefore <em>PyMongo</em> needs to be installed on your machine. To do so you cane use the following command.</p>
<pre><code>pip install pymongo
</code></pre>
<p>The library can now be used inside any Python program. See an example use case below.</p>
<hr />
<h2 id="usage-example">Usage &amp; Example</h2>
<p>In general the library can be used in any Python program, you simply import the needed component. It can also be used in conjunction with other process mining and data science tools, especially  <a href="http://www.pm4py.org">PM4Py</a>.</p>
<p>A simple example program using the library can be found below.</p>
<pre><code>    from pm4py.visualization.dfg import factory as dfg_vis_factory

    import importer
    import filter
    import dfg

    # Import a CSV file
    database = importer.create_from_csv("dataset", "/data.csv", batchsize=50000)

    # Filter the log based on the end activity
    filtered_end = filter.case_ends_with("Rejected", database, result_collection="filteredEnd")

    # Calculate the performance based dfg and get the edges as a dictionary
    dfg.calculate(database, filtered_end, variant="performance")
    edges = dfg.get_dict(database)

    # Visualize the dfg using PM4Py
    visualization = dfg_vis_factory.apply(edges, variant="performance")
    dfg_vis_factory.view(visualization)
</code></pre></div>
        </div>

        <footer class="col-md-12">
            <hr>
            <p>Documentation built with <a href="https://www.mkdocs.org/">MkDocs</a>.</p>
        </footer>
        <script>
            var base_url = ".",
                shortcuts = {"help": 191, "next": 78, "previous": 80, "search": 83};
        </script>
        <script src="js/base.js" defer></script>
        <script src="search/main.js" defer></script>

        <div class="modal" id="mkdocs_search_modal" tabindex="-1" role="dialog" aria-labelledby="Search Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Search</h4>
            </div>
            <div class="modal-body">
                <p>
                    From here you can search these documents. Enter
                    your search terms below.
                </p>
                <form role="form">
                    <div class="form-group">
                        <input type="text" class="form-control" placeholder="Search..." id="mkdocs-search-query" title="Type search term here">
                    </div>
                </form>
                <div id="mkdocs-search-results"></div>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div><div class="modal" id="mkdocs_keyboard_modal" tabindex="-1" role="dialog" aria-labelledby="Keyboard Shortcuts Modal" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span><span class="sr-only">Close</span></button>
                <h4 class="modal-title" id="exampleModalLabel">Keyboard Shortcuts</h4>
            </div>
            <div class="modal-body">
              <table class="table">
                <thead>
                  <tr>
                    <th style="width: 20%;">Keys</th>
                    <th>Action</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td class="help shortcut"><kbd>?</kbd></td>
                    <td>Open this help</td>
                  </tr>
                  <tr>
                    <td class="next shortcut"><kbd>n</kbd></td>
                    <td>Next page</td>
                  </tr>
                  <tr>
                    <td class="prev shortcut"><kbd>p</kbd></td>
                    <td>Previous page</td>
                  </tr>
                  <tr>
                    <td class="search shortcut"><kbd>s</kbd></td>
                    <td>Search</td>
                  </tr>
                </tbody>
              </table>
            </div>
            <div class="modal-footer">
            </div>
        </div>
    </div>
</div>

    </body>
</html>

<!--
MkDocs version : 1.0.4
Build Date UTC : 2019-10-01 18:40:56
-->
